# Retrieve Paginated Findings of a TOE
source: https://developer.mastercard.com/riskrecon-api/documentation/use-cases/risk-assessment/findings/retrve-fnd-for-toe/index.md

## Overview {#overview}

You can use the `GET Paginated Findings` endpoint to retrieve a list of open findings for the latest analysis of a TOE. You must provide the `toe_id` as the endpoint request parameter to retrieve all the findings for that TOE in the response.

### Filter parameters {#filter-parameters}

RiskRecon recommends using filtering capabilities to limit the amount of data that comes back in the response by using [pagination parameters](https://developer.mastercard.com/riskrecon-api/documentation/use-cases/index.md#pagination-metadata) and the following query parameters in the API request:

* **Filter by an asset value** : You can use the `asset_value` parameter to search for findings with high, medium, or low asset value.
* **Filter by issue severity** : You can use the `severity` parameter to search for findings of high, medium, or low severity.
* **Filter by asset value and issue severity** : You can use both the `asset_value` and `severity` parameters to search for findings with high, medium, or low asset value and severity.
* **Filter by multiple asset values** : You can use the `asset_value` parameter multiple times to search for findings with multiple asset values.
* **Filter by security domain** : You can use the `security_domain` parameter to search for findings of a particular security domain, such as Software Patching (software_patching), Application Security (web_app_security),
* **Filter by security criteria** : You can use the `security_criteria` parameter to search for findings for a particular security criteria within a security domain, such as High Value System Encryption (unencrypted_sensitive_systems) and CMS Authentication (config_web_cms_authentication) within the Application Security domain
* **Filter by CVE ID** : You can also use the `cve_ids` array parameter to search for findings by [CVE ID](https://developer.mastercard.com/riskrecon-api/documentation/glossary/index.md#common-vulnerabilities-and-exposures).

Note: The `GET Findings` endpoint is a legacy endpoint. It can also be used to retrieve list of open findings for the latest analysis of a TOE and you must provide the `toe_id` as the request parameter for this legacy endpoint.

The `GET Findings` endpoint does not support pagination, hence RiskRecon recommends using the `GET Paginated Findings` endpoint instead.

### View findings on the RiskRecon portal {#view-findings-on-the-riskrecon-portal}

You can see findings in multiple places of the **RiskRecon portal**:

* The Security Profile page
* The Issue Priority Matrix on the Dashboard page
* The Data Search page

<br />

A pictorial representation of the filters as seen in the \*\*Data Search\*\* tab of the \*\*RiskRecon web portal\*\* is shown in the image here:

![](https://static.developer.mastercard.com/content/riskrecon-api/uploads/findings1.png)

## Sequence Diagram {#sequence-diagram}

The following diagram shows how to retrieve a list of findings for the latest analysis of a TOE:
Diagram retrieve-findings

## Execution Steps {#execution-steps}

The following steps describe how to retrieve a list of findings for the latest analysis of a TOE:

1. The user sends a `GET` request to retrieve a list of findings for the latest analysis of a TOE and provides the `toe_id` as the input parameter.
2. RiskRecon provides the list of findings for the latest analysis of the requested TOE.

## Sample Request and Response {#sample-request-and-response}

For a sample request and response of this API, see [Get Paginated Findings of a TOE](https://developer.mastercard.com/riskrecon-api/documentation/testing/findings-samples/retrve-fnd-smpl/index.md).

## Use Case Example {#use-case-example}

The use cases in this section discuss how you can use the `GET Paginated Findings` endpoint to retrieve a list of findings for the latest analysis of a TOE:

* [Tracking vendor issues overtime](https://developer.mastercard.com/riskrecon-api/documentation/use-cases/risk-assessment/findings/retrve-fnd-for-toe/index.md#tracking-vendor-issues-overtime)
* [Determining the security risk posture while vetting potential vendors](https://developer.mastercard.com/riskrecon-api/documentation/use-cases/risk-assessment/findings/retrve-fnd-for-toe/index.md#determining-the-security-risk-posture-of-a-vetting-vendor)

### Tracking vendor issues overtime {#tracking-vendor-issues-overtime}

A vendor has been operating with an old version of a software for more than a year. In spite of repeated reminders to upgrade the software, the RiskRecon customer, finds over time, that the same issue is retrieved. This is because every time the `GET Paginated Findings` endpoint is executed, the same `finding_id` shows up in the endpoint response. The customer has therefore decided to discontinue business with the vendor as they can no longer risk exposing their systems to security vulnerabilities arising from operating on a backdated version of the software.

### Determining the security risk posture while vetting potential vendors {#determining-the-security-risk-posture-while-vetting-potential-vendors}

A RiskRecon customer is vetting a vendor and needs to know the vendor's security risk posture. The user can use the `GET Paginated Findings` endpoint to review a list of all the vendor's current risks. Seeing how many current risks a vendor has can be helpful in determining the vendor's security risk posture. The user can then evaluate if they should do business with that vendor and take on the potential risk.

## Endpoint {#endpoint}


API Reference: `GET /v1/findings_paginated/{toe_id}`

## Legacy Endpoint {#legacy-endpoint}


API Reference: `GET /v1/findings/{toe_id}`

